Index: gsdl/branches/gsdl-2.74/perllib/plugins/MediaWikiPlug.pm
===================================================================
--- gsdl/branches/gsdl-2.74/perllib/plugins/MediaWikiPlug.pm	(revision 14268)
+++ gsdl/branches/gsdl-2.74/perllib/plugins/MediaWikiPlug.pm	(revision 14270)
@@ -651,3 +624,35 @@
 }
 
+sub safe_escape_regexp
+{
+  my $regexp = shift (@_);
+  
+  # if ($ENV{'GSDLOS'} =~ /^windows$/i) {
+    $regexp =~ s/\\/\\\\/isg;    
+  #} else {
+    $regexp =~ s/\//\\\//isg;         
+  #}
+  return $regexp;
+}
+
+sub read_content_from_about_dm
+{
+  my $about_macro_file = &util::filename_cat($ENV{'GSDLHOME'}, "macros", "about.dm");
+  my $about_page_content = "";
+  if (open(INPUT, "<$about_macro_file")){
+    while (my $line=<INPUT>){
+      $about_page_content .= $line;
+    }
+  } else {
+    print $outhandle "can't open file $about_macro_file\n";
+  }    		
+  close(INPUT);
+            
+  # extract the _content_ macro
+  $about_page_content =~ m/_content_ {(.|\n)*<\/div>\n\n<\/div>\n}/i;
+  $about_page_content = $&;
+  
+  return $about_page_content;
+}
+
 1;
Index: gsdl/branches/gsdl-2.74/src/recpt/authenaction.cpp
===================================================================
--- gsdl/branches/gsdl-2.74/src/recpt/authenaction.cpp	(revision 14268)
+++ gsdl/branches/gsdl-2.74/src/recpt/authenaction.cpp	(revision 14270)
@@ -33,5 +33,4 @@
 #include "infodbclass.h"
 #include "gsdltimes.h"
-#include "userdb.h"
 
 
@@ -129,23 +128,12 @@
 
 void authenaction::configure (const text_t &key, const text_tarray &cfgline) {
-  // get the password filename
-  if (cfgline.size() == 1) {
-    if (key == "usersfile") usersfile = cfgline[0];
-    else if (key == "keyfile") keyfile = cfgline[0];
-    else if (key == "keydecay") keydecay = cfgline[0].getint();
-  }
-
   action::configure (key, cfgline);
 }
 
 bool authenaction::init (ostream &logout) {
-
   if (gdbmhome.empty()) {
     logout << "ERROR (authenaction::init) gdbmhome is not set\n";
     return false;
   }
-
-  if (usersfile.empty()) usersfile = filename_cat (gdbmhome, "etc", "users.db");
-  if (keyfile.empty()) keyfile = filename_cat (gdbmhome, "etc", "key.db");
 
   return action::init (logout);
@@ -169,7 +157,4 @@
   if (args["uan"].empty()) return true;
 
-  userdbclass *user_database = new userdbclass(usersfile);
-  keydbclass *key_database = new keydbclass(keyfile);
-
   // failure means we have to redirect to this action to get authentication
   // (if we are not already doing this)
@@ -188,6 +173,7 @@
   else args_us = "failed";
 
-  // make sure we have a username
-  if (!args_un.empty() && (user_database->get_user_info (args_un, thisuser) == ERRNO_SUCCEED)) {
+  // make sure we have a username                                                                                                 
+  int status = user_database->get_user_info (args_un, thisuser);
+  if (!args_un.empty() && (status == ERRNO_SUCCEED)) {
     if (!args_pw.empty()) {
       // we are authenticating using a password
@@ -286,7 +272,4 @@
   }
 
-  //close the database
-  user_database->closedatabase();
-  key_database->closedatabase();
   return true;
 }
Index: gsdl/branches/gsdl-2.74/src/recpt/authenaction.h
===================================================================
--- gsdl/branches/gsdl-2.74/src/recpt/authenaction.h	(revision 14268)
+++ gsdl/branches/gsdl-2.74/src/recpt/authenaction.h	(revision 14270)
@@ -33,4 +33,5 @@
 #include "action.h"
 #include "text_t.h"
+#include "userdb.h"
 #include "receptionist.h"
 
@@ -41,6 +42,6 @@
 class authenaction : public action {
 protected:
-  text_t usersfile;
-  text_t keyfile;
+  userdbclass *user_database;
+  keydbclass *key_database;
   int keydecay;
 
@@ -50,4 +51,8 @@
   authenaction ();
   virtual ~authenaction () {}
+
+  void set_userdb(userdbclass *udb) {user_database = udb;}
+
+  void set_keydb (keydbclass *kdb) {key_database = kdb;}
 
   void set_receptionist (receptionist *therecpt) {recpt=therecpt;}
Index: gsdl/branches/gsdl-2.74/src/recpt/librarymain.cpp
===================================================================
--- gsdl/branches/gsdl-2.74/src/recpt/librarymain.cpp	(revision 14268)
+++ gsdl/branches/gsdl-2.74/src/recpt/librarymain.cpp	(revision 14270)
@@ -178,6 +178,14 @@
   recpt.add_action (adocumentaction);
 
+  text_t userdbfile = filename_cat(gsdlhome, "etc", "users.db");
+  userdbclass *udb = new userdbclass(userdbfile);
+
+  text_t keydbfile = filename_cat(gsdlhome, "etc", "key.db");
+  keydbclass *kdb = new keydbclass(keydbfile);
+
 #ifdef GSDL_USE_USERS_ACTION
-  recpt.add_action (new usersaction());
+  usersaction *ausersaction = new usersaction();
+  ausersaction->set_userdb(udb);
+  recpt.add_action (ausersaction);
 #endif
 
@@ -190,4 +198,6 @@
 #ifdef GSDL_USE_AUTHEN_ACTION
   authenaction *aauthenaction = new authenaction();
+  aauthenaction->set_userdb(udb);
+  aauthenaction->set_keydb(kdb);
   aauthenaction->set_receptionist(&recpt);
   recpt.add_action (aauthenaction);
@@ -272,4 +282,6 @@
   cgiwrapper (recpt, "");
   delete cservers;
+  delete udb;
+  delete kdb;
 
   // clean up the actions
Index: gsdl/branches/gsdl-2.74/src/recpt/userdb.cpp
===================================================================
--- gsdl/branches/gsdl-2.74/src/recpt/userdb.cpp	(revision 14268)
+++ gsdl/branches/gsdl-2.74/src/recpt/userdb.cpp	(revision 14270)
@@ -77,5 +77,16 @@
 userdbclass::userdbclass(const text_t &userdbfilename)
 {
-  activated = (!userdb.opendatabase(userdbfilename, GDBM_WRCREAT, 1000, true)) ? false : true;
+  storeduserdbfilename = userdbfilename;
+  activated = (!userdb.opendatabase(storeduserdbfilename, GDBM_READER, 1000, true)) ? false : true;
+  if (activated == false) 
+    {
+      activated = (!userdb.opendatabase(storeduserdbfilename, GDBM_WRCREAT, 1000, true)) ? false : true;
+      if (activated == true)
+        {
+          userdb.closedatabase();
+          activated = (!userdb.opendatabase(storeduserdbfilename, GDBM_READER, 1000, true)) ? false : true;
+        }
+    }
+    
   external_db = false;
 }
@@ -227,6 +238,10 @@
       info["groups"] = userinfo.groups;
       info["comment"] = userinfo.comment;
-      
-      return (userdb.setinfo (username, info)) ? ERRNO_SUCCEED : ERRNO_GDBMACTIONFILED ;
+      userdb.closedatabase();
+      userdb.opendatabase(storeduserdbfilename, GDBM_WRCREAT, 1000, true);
+      int result = (userdb.setinfo (username, info)) ? ERRNO_SUCCEED : ERRNO_GDBMACTIONFILED;
+      userdb.closedatabase();
+      userdb.opendatabase(storeduserdbfilename, GDBM_READER, 1000, true);         
+      return  result;
     }
   return ERRNO_CONNECTIONFAILED;
@@ -290,5 +305,9 @@
   if (activated == true)
     {
+      userdb.closedatabase();
+      userdb.opendatabase(storeduserdbfilename, GDBM_WRCREAT, 1000, true);
       userdb.deletekey (username);
+      userdb.closedatabase();
+      userdb.opendatabase(storeduserdbfilename, GDBM_READER, 1000, true);
       return ERRNO_SUCCEED;
     }
@@ -335,11 +354,4 @@
   return ERRNO_CONNECTIONFAILED;
 }
-
-//an alernative way to colse the database if the class can't reach the destructor
-void userdbclass::closedatabase()
-{
-   userdb.closedatabase();
-}
-
 //==========================================//
 //       userdbclass functions (End)        //
@@ -351,5 +363,15 @@
 keydbclass::keydbclass(const text_t &keydbfilename)
 {
-  activated = (!keydb.opendatabase(keydbfilename, GDBM_WRCREAT, 1000, true)) ? false : true;
+  storedkeydbfilename = keydbfilename;
+  activated = (!keydb.opendatabase(storedkeydbfilename, GDBM_READER, 1000, true)) ? false : true;
+  if (activated == false) 
+    {
+      activated = (!keydb.opendatabase(storedkeydbfilename, GDBM_WRCREAT, 1000, true)) ? false : true;
+      if (activated == true)
+        {
+          keydb.closedatabase();
+          activated = (!keydb.opendatabase(storedkeydbfilename, GDBM_READER, 1000, true)) ? false : true;
+        }
+    }
   external_db = false;
 }
@@ -399,8 +421,12 @@
       keydata["time"] = time2text(time(NULL));
       
+      keydb.closedatabase();
+      keydb.opendatabase(storedkeydbfilename, GDBM_WRCREAT, 1000, true);
       if (!keydb.setinfo (crypt_userkey, keydata)) 
         {
           userkey.clear(); // failed
         }
+      keydb.closedatabase();
+      keydb.opendatabase(storedkeydbfilename, GDBM_READER, 1000, true); 
       
       return userkey;
@@ -434,5 +460,9 @@
             // succeeded, update the key's time
             info["time"] = time2text(time(NULL));
+            keydb.closedatabase();
+            keydb.opendatabase(storedkeydbfilename, GDBM_WRCREAT, 1000, true);
             keydb.setinfo (crypt_key, info);
+            keydb.closedatabase();
+            keydb.opendatabase(storedkeydbfilename, GDBM_READER, 1000, true); 
             return true;
           }
@@ -477,10 +507,4 @@
     }
 }
-
-//an alernative way to colse the database if the class can't reach the destructor
-void keydbclass::closedatabase()
-{
-   keydb.closedatabase();
-}
 //==========================================//
 //       keydbclass functions (End)         //
Index: gsdl/branches/gsdl-2.74/src/recpt/userdb.h
===================================================================
--- gsdl/branches/gsdl-2.74/src/recpt/userdb.h	(revision 14268)
+++ gsdl/branches/gsdl-2.74/src/recpt/userdb.h	(revision 14270)
@@ -64,4 +64,5 @@
   bool external_db;
   bool activated;
+  text_t storeduserdbfilename; 
   
  public:
@@ -114,7 +115,4 @@
   // on success
   int get_user_list (text_tarray &userlist);
-
-  //an alernative way to colse the database if the class can't reach the destructor
-  void closedatabase();
 };
 
@@ -126,4 +124,5 @@
   bool external_db;
   bool activated;
+   text_t storedkeydbfilename; 
   
  public:
@@ -146,7 +145,4 @@
   // use sparingly, it can be quite an expensive function
   void remove_old_keys (int keydecay);
-
- //an alernative way to colse the database if the class can't reach the destructor
-  void closedatabase();
 };
 
Index: gsdl/branches/gsdl-2.74/src/recpt/usersaction.cpp
===================================================================
--- gsdl/branches/gsdl-2.74/src/recpt/usersaction.cpp	(revision 14268)
+++ gsdl/branches/gsdl-2.74/src/recpt/usersaction.cpp	(revision 14270)
@@ -147,9 +147,4 @@
 
 void usersaction::configure (const text_t &key, const text_tarray &cfgline) {
-  // get the password filename
-  if (cfgline.size() == 1) {
-    if (key == "usersfile") usersfile = cfgline[0];
-  }
-
   action::configure (key, cfgline);
 }
@@ -161,6 +156,4 @@
     return false;
   }
-
-  if (usersfile.empty()) usersfile = filename_cat (gdbmhome, "etc", "users.db");
 
   return action::init (logout);
@@ -193,7 +186,4 @@
 			     outconvertclass &outconvert, ostream &textout, 
 			     ostream &logout) {
-
-  // open the user database (it will be used a lot)
-  user_database = new userdbclass(usersfile);
 
   if (args["uma"] == "adduser" || args["uma"] == "edituser") {
Index: gsdl/branches/gsdl-2.74/src/recpt/usersaction.h
===================================================================
--- gsdl/branches/gsdl-2.74/src/recpt/usersaction.h	(revision 14268)
+++ gsdl/branches/gsdl-2.74/src/recpt/usersaction.h	(revision 14270)
@@ -32,12 +32,11 @@
 #include "gsdlconf.h"
 #include "action.h"
+#include "userdb.h"
 #include "text_t.h"
-#include "userdb.h"
 
 
 class usersaction : public action {
 protected:
-  text_t usersfile;
-  userdbclass* user_database;
+  userdbclass *user_database;
 
 public:
@@ -48,4 +47,6 @@
 
   bool init (ostream &logout);
+
+  void set_userdb(userdbclass *udb) {user_database = udb;}
   
   text_t get_action_name () {return "um";}
